﻿/*global radio0, radio1, radio2, radio3, radio4, radio5, radio6, radio7, radio8, radio9, radio25, radio26, radio27, radio28, radio29, radio30, radio31, radio32, radio33, radio34, radio35, radio36, radio37, radio38, radio39, radio40, radio41, radio42, radio43, radio44, menu0, menu1, ctrl, pingAddy, pingStore, ppout, line1, line2, line3, line4, vtext, but0, but1, but2, but3, but4, nd0, nd1, nd2, nd3, nd4, remList, addList, ok5, ok4, cancel6, cancel1, page0, ok1, ok6, PingHome, nDetect, line4b, line1b, nInfo, nData, NICselect1, NICselect2, rline6, rline5, rline0, dnhist, uphist, GetWanIp, GetLanIp, dnInput, upInput, infobox, but10, but11, arrowCover, bg, bod, ctrl1, ctrl0, radio47, radio48, radio49, radio50, radio51, rline8, rline9, nd5, rline10, rline4, radio45, radio46, arrowCover2, arrowCover3 */
/////////////////////Globals////////////////////////////////////////////////////////////
var locator=null;
var refresher=null;
var server=null;
var net=null;
var NIC1="Combined Traffic";         //Adapter name used to retrieve bytespersec
var NIC2=false;         //Adapter name used to retrieve all other info
var t=null;                //time variable for main setTimeout
var g=null;                //time variable for save settings setTimeout
var h=null;                //time variable for ping tool
var b=null;                //time variable for histogram expansion
var maxSpeed=[0,0];     //apex bytespersec
var nicInfo=[];         //array for adapter info from vbscripts
var upbarht=[];         //histogram values
var dnbarht=[];         //histogram values
var reset=true;         //allows functions to refresh display even with zero bytes
var total=[0,0];        //keeps approx running totals
var histoLength=0;     //histogram array length values used (30,110)
var interval=1500;      //milliseconds  values (250,500,750,1000,1500,2000)
var barMax=[0.001,0.001];      //barMax max bar height values(>0)
var barMin=0;           //min bar height values(0,0.1,1)
var precision=[2,1,2];  //precision kb, mb, gb
var auto=1;             //histogram auto mode on/off values (0,1)
var lineMode=1;         //center display mode values (0,1,2,3,4,5,6)
var fMode=1;            //gradient bar filter on/off values (0,1)
var autoMin=1;          //minimum auto peak values (0,1,2)
var nonic=2;
var hDir=[0,0];
var oGD=System.Gadget.document;
var ipList=[];
var lastSave=[];
var clr=["#39f","#f00","#616161","#616161","#777","#898989","#c00","#aaa","#39f","#6cf","#fc6","#f60","#909","#03f","#808080","#444"];
//color[0] general hover
//color[1] on state
//color[2] left label
//color[3] border color
//color[4] border hover
//color[5] middle lines text color
//color[6] on state hover
//color[7] bytespersec
//color[8] ok
//color[9] ok hover
//color[10] cancel
//color[11] cancel hover
//color[12] upload bars
//color[13] download bars
//color[14] radio buttons
//color[15] border click
///////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////
System.Gadget.settingsUI="settings.html";
Array.prototype.max=function(A,B){var i=1;for(i;i<A;i++){if(this[i]>B){B=this[i];}}return B;};
Number.prototype.thruPut=function(){return (this>1024)?(this/1024).toFixed(precision[1])+" mb/s":this.toFixed(precision[0])+" kb/s";};
Number.prototype.ttal=function(){return (this>1048576)?(this/1048576).toFixed(precision[2])+" gb":(this/1024).toFixed(precision[1])+" mb";};
Number.prototype.ht=function(A){return Math.min(Math.ceil(this*10/(Math.max(A,autoMin))),10)+"px";};
Number.prototype.paint=function(A){return (this>barMin)?clr[A]:"transparent";};
String.prototype.loadInt=function(){var v=this.split("=");v=parseInt(v[1],10);return v;};
String.prototype.loadFloat=function(){var v=this.split("=");v=parseFloat(v[1]);return v;};
function initActivX(){
 locator=new ActiveXObject("WbemScripting.SWbemLocator");
 server=locator.ConnectServer(".","root/cimv2");
 server.Security_.ImpersonationLevel=3;
 refresher=new ActiveXObject("WbemScripting.SWbemRefresher");
 net=refresher.AddEnum(server,"Win32_PerfFormattedData_Tcpip_NetworkInterface").ObjectSet;
}
function setTitles(){
 radio47.title="Set the minimum value to\rappear in the histogram";
 radio48.title="Set the minimum value to\rhave 100% height in the\rhistogram in auto mode";
 radio7.title="All activity\rwill be shown\ron the histogram.";
 radio8.title="Activity < 0.1 kb/s\rwill not be shown\ron the histogram.";
 radio9.title="Activity < 1 kb/s\rwill not be shown\ron the histogram.";
 radio49.title="Any peak value,\rno matter how small,\rwill have 100% height\rin the histogram.";
 radio50.title="A peak value of 1 kb/s\rwill be the lowest value\rto have 100% height\rin the histogram.";
 radio51.title="A peak value of 2 kb/s\rwill be the lowest value\rto have 100% height\rin the histogram.";
}
function checkRtClick(){
 var rightclick, e=window.event;
 if(e.button){rightclick=((e.button===4)||(e.button===3));return rightclick;}
}
function boxInfo(A){
 var clipText;
 clipText="Adapter\t: "+nicInfo[2];
 clipText+="\r\nS/Name\t: "+nicInfo[3];
 clipText+="\r\nIPv4\t: "+nicInfo[0];
 clipText+="\r\nIPv6\t: "+nicInfo[5];
 clipText+="\r\nSubNet\t: "+nicInfo[6];
 clipText+="\r\nGate IP\t: "+nicInfo[7];
 clipText+="\r\nWAN IP\t: "+nicInfo[4];
 clipText+=(nicInfo[8]!=="False")?"\r\nDHCP\t: "+nicInfo[9]:"False";
 clipText+="\r\nDNS 1\t: "+nicInfo[10];
 clipText+=(nicInfo[11]!=="")?"\r\nDNS 2\t: "+nicInfo[11]:"";
 clipText+="\r\nNetBios\t: "+nicInfo[12];
 clipText+="\r\nData\t: "+NIC1;
 clipText+="\r\nMax Rx\t: "+maxSpeed[0].thruPut();
 clipText+="\r\nMax Tx\t: "+maxSpeed[1].thruPut();
 clipText+="\r\nUpLd\t: "+total[0].ttal();
 clipText+="\r\nDnLd\t: "+total[1].ttal();
 infobox.title="Left Click to Cycle Display\r\nCopy to Clipboard with Middle-Click\r\n"+clipText;
 if(A){window.clipboardData.setData('Text',clipText);}
}
function shutdown(){
 clearTimeout(g);
 clearTimeout(t);
 net=refresher.DeleteAll();
}
function saveSettings(){
 var mode=[barMax[0],barMax[1],barMin,precision[0],precision[1],precision[2],interval,lineMode,auto,fMode,autoMin,hDir[0],hDir[1]];
 if(mode.toString()!==lastSave.toString()){lastSave=mode;System.Gadget.Settings.write("mode",mode);}
}
function act(A,B,C,D,E){
 if(A){D.style.color=A;}
 if(B){D.innerHTML=B;}
 if(C){D.style.filter="progid:DXImageTransform.Microsoft.Alpha(Opacity=100, FinishOpacity=40, Style="+C+")";}
 if(E){D.style.borderColor=E;}
}
function loadInputs(){
 upInput.innerText=Math.ceil(barMax[0]);
 dnInput.innerText=Math.ceil(barMax[1]);
}
function getNicInfo(){
 nicInfo=GetLanIp(NIC2).split(";");
 if((nicInfo[0]==="0.0.0.0")&&(nicInfo[5]==="Not Enabled")&&(NIC2!==false)){
  NIC2=false;
  nicInfo=GetLanIp(false).split(";");
 }
}
function getWan(){
 nicInfo[4]=GetWanIp();
 boxInfo();
 if(lineMode===6){
  line3.innerText=nicInfo[4];
 }
}
function addBars(){
 var i, j=histoLength+2, lmax;
 lmax=(lineMode===0)?110:30;
 if(histoLength<lmax){
  for(i=histoLength;i<j;i++){		
   uphist.innerHTML+='<span id="uphis'+i+'" class="ubar"></span>';
   dnhist.innerHTML+='<span id="dnhis'+i+'" class="dbar"></span>';
  }
  histoLength=j;
  uphist.style.left=(hDir[0]===0)?"10px":(10+lmax-j)+"px";
  dnhist.style.left=(hDir[1]===0)?"10px":(10+lmax-j)+"px";
  uphist.style.width=dnhist.style.width=j+"px";
  b=setTimeout(addBars,interval);
 }
}
function setLines(A){
 var i, str2, str3, strv;
 if(A===true){boxInfo();}
 if(lineMode>6){lineMode=0;}
 clearTimeout(b);
 addBars();
 if(lineMode>0){
  if(histoLength>30){
   uphist.style.width=dnhist.style.width="30px";
   dnbarht=dnbarht.slice(0,29);
   upbarht=upbarht.slice(0,29);
   for(i=histoLength-1;i>29;i--){
    if(oGD.getElementById("uphis"+i)){uphist.removeChild(oGD.getElementById("uphis"+i));}
    if(oGD.getElementById("dnhis"+i)){dnhist.removeChild(oGD.getElementById("dnhis"+i));}
   }
   histoLength=30;
  }
  uphist.style.left=(hDir[0]===0)?"10px":(10+30-histoLength)+"px";
  dnhist.style.left=(hDir[1]===0)?"10px":(10+30-histoLength)+"px";
  line2.style.display=line3.style.display=vtext.style.display="block";
 }
 switch(lineMode){
  case 1:str2=barMax[0].thruPut();str3=barMax[1].thruPut();strv="peak";break;//Peaks
  case 2:str2=maxSpeed[0].thruPut();str3=maxSpeed[1].thruPut();strv="apex";break;//Apex
  case 3:str2=total[0].ttal();str3=total[1].ttal();strv="total";break;//Totals
  case 4:str2=nicInfo[2].split(" ",1);str3=nicInfo[3];strv="nic";break;//Model, Manufacturer
  case 5:str2=(nicInfo[1]!=="MAC Unknown")?nicInfo[1].slice(0,9):"MAC";str3=(nicInfo[1]!=="MAC Unknown")?nicInfo[1].slice(9):"Unknown";strv="mac";break;// MAC
  case 6:str2=(nicInfo[0]==="0.0.0.0")?nicInfo[5]:nicInfo[0];str3=nicInfo[4];strv="ip";break;//IP
  default:line2.style.display=line3.style.display="none";strv="";//Blank
 }
 vtext.innerText=strv;
 line2.innerText=str2;
 line3.innerText=str3;
 reset=true;
}
function changeLines(){
 clearTimeout(g);
 lineMode++;
 setLines(true);
 g=setTimeout(saveSettings,5000);
}
function closeLines(A){
 var i, j=28, k=8;
 if((A>3)&&(A<8)){j=29;k=5;}
 for(i=1;i<k;i++){oGD.getElementById("rline"+i).style.display="none";}
 for(i=j;i<32;i++){oGD.getElementById("radio"+i).style.display="block";}
}
function closeLines2(){
 rline0.style.display=rline8.style.display=rline9.style.display="none";
 radio27.style.display="block";
}
function changePage(A,B){
 var el;
 el=(A===undefined)?this.parentNode:oGD.getElementById("page"+A);
 if(B===undefined){B=0;}
 bg.src=(B===0)?"images\\back60.png":"images\\back85.png";
 oGD.body.style.height=bg.style.height=(B===0)?"60px":((B===6)&&(nd5.innerText==="Hide Tools"))?"178px":"85px";
 bod.style.paddingTop=((B===3)||(B===4))?"5px":"6px";
 vtext.opacity=(B===0)?100:0;
 el.style.display="none";
 oGD.getElementById("page"+B).style.display="block";
 if((A===4)||(el.id==="page4")){closeLines();}
 if((A===1)||(el.id==="page1")){closeLines2();}
}
function pushLine(A,B,C){
 var el=oGD.getElementById('combo'+B);
 if(A<5){closeLines(A);}
 el.filters.item(0).Apply();
 if(A>7){rline0.style.display="none";}
 C.style.display="none";
 oGD.getElementById("rline"+A).style.display="block";
 el.filters.item(0).Play();
}
function resetTotals(A,B){
 if(A){maxSpeed[0]=0;maxSpeed[1]=0;}
 if(B){total[0]=0;total[1]=0;}
 reset=true;
}
function onButtonIn(){this.style.color=clr[6];}
function onButtonOut(){this.style.color=clr[1];}
function offButtonIn(){act(clr[0],"","",this,clr[4]);}
function offButtonOut(){act(clr[14],"","",this,clr[3]);}
function setButtons(A,B){
 var i, el, z=[5,32,64,192,1000,81920], y=[0,0.1,1], v=[250,500,750,1000,1500,2000];
 for(i=A;i<B;i++){
  el=oGD.getElementById("radio"+i);
  if(((z[i]===barMax[1])&&(auto===0))||((i-5===auto)&&(auto===1))||(y[i-7]===barMin)||(v[i-10]===interval)||(i-16===precision[0])||(i-19===precision[1])||(i-22===precision[2])||(i-38===fMode)||((i===49)&&(autoMin===0.001))||(i-49===autoMin)||(i-40===hDir[0])||(i-42===hDir[1])){
   el.style.color=clr[1];
   el.style.borderStyle="inset";
   el.onmouseenter=onButtonIn;
   el.onmouseleave=onButtonOut;
  }
  else{
   el.style.color=clr[14];
   el.style.borderStyle="outset";
   el.onmouseenter=offButtonIn;
   el.onmouseleave=offButtonOut;
  }
 }
}
function changeInterval(){
 clearTimeout(g);
 interval=this.value;
 setButtons(10,16);
 changePage(2,0);
 g=setTimeout(saveSettings,5000);
}
function setHistF(A){
 uphist.filters.item(0).Style=dnhist.filters.item(0).Style=A;
}
function changeHistF(A){
 clearTimeout(g);
 fMode=A;
 setHistF(fMode);
 setButtons(38,40);
 changePage(4,0);
 closeLines();
 g=setTimeout(saveSettings,5000);
}
function changePrecision(){
 var el, i;
 clearTimeout(g);
 for(i=16;i<25;i++){
  if(event.srcElement.id==="radio"+i){el=(i<19)?0:(i<22)?1:2;}
 }
 precision[el]=event.srcElement.value;
 reset=true;
 setButtons(16,25);
 changePage(3,0);
 g=setTimeout(saveSettings,5000);
}
function changeBarMax(A,B){
 clearTimeout(g);
 if(A<=0){A=0.001;}
 if(B<=0){B=0.001;}
 barMax=[A,B];
 reset=true;
 closeLines2();
 setButtons(0,7);
 changePage(1,0);
 g=setTimeout(saveSettings,5000);
}
function changeBarMin(A){
 clearTimeout(g);
 closeLines2();
 barMin=A;
 reset=true;
 setButtons(7,10);
 changePage(1,0);
 g=setTimeout(saveSettings,5000);
}
function changeAutoMin(){
 clearTimeout(g);
 closeLines2();
 autoMin=this.value;
 if(autoMin<=0){autoMin=0.001;}
 reset=true;
 setButtons(49,52);
 changePage(1,0);
 g=setTimeout(saveSettings,5000);
}
function chooseNIC(A){
 if(A===1){NIC1=NICselect1.options[NICselect1.options.selectedIndex].value;nData.innerText=nData.title=(NIC1!=="Combined Traffic")?NIC1:"Combined Traffic";}
 if(A===2){NIC2=nInfo.innerText=nInfo.title=NICselect2.options[NICselect2.options.selectedIndex].value;}
}
function selectNic(){
 var e, i, nList, rset=true, temp;
 for(i=NICselect1.length;i>0;i--){NICselect1.remove(i-1);}
 for(i=NICselect2.length;i>0;i--){NICselect2.remove(i-1);}
 e=new Enumerator(net);
 NICselect1.options[0]=new Option("Combined Traffic","Combined Traffic",true,false);
 for(i=1;!e.atEnd();e.moveNext()&i++){
  if(e.item().Name!=="MS TCP Loopback interface"){NICselect1.options[i]=new Option(e.item().Name,e.item().Name);}
  else{i--;}
 }
 nList=GetLanIp("list").split(";");
 for(i=0;i<nList.length;i++){NICselect2.options[i]=new Option(nList[i],nList[i]);if(NIC2===nList[i]){rset=false;}}
 if(NIC1!=="Combined Traffic"){NICselect1.value=NIC1;}
 nData.innerText=nData.title=(NIC1!=="Combined Traffic")?NIC1:"Combined Traffic";
 if(rset===true){NIC2=false;temp=nicInfo[4];getNicInfo();nicInfo[4]=temp;}
 NICselect2.value=nInfo.innerText=nInfo.title=(NIC2!==false)?NIC2:nicInfo[2];
 changePage(4,5);
}
function saveNic(){
 var temp=nicInfo[4];
 getNicInfo();
 nicInfo[4]=temp;
 setLines(true);
 changePage(5,0);
 System.Gadget.Settings.write("NIC1",NIC1);
 System.Gadget.Settings.write("NIC2",NIC2);
}
function showUpHist(A){
 var i, el;
 if(A>histoLength){upbarht.pop();A--;}
 if(auto===1){barMax[0]=Math.max(upbarht.max(A,upbarht[0]),0.001);}
 for(i=0;i<upbarht.length;i++){
  el=oGD.getElementById('uphis'+i);
  el.style.backgroundColor=upbarht[i].paint(12);
  el.style.height=upbarht[i].ht(barMax[0]);
 }
}
function showDnHist(A){
 var i, el;
 if(A>histoLength){dnbarht.pop();A--;}
 if(auto===1){barMax[1]=Math.max(dnbarht.max(A,dnbarht[0]),0.001);}
 for (i=0;i<dnbarht.length;i++){
  el=oGD.getElementById('dnhis'+i);
  el.style.backgroundColor=dnbarht[i].paint(13);
  el.style.height=dnbarht[i].ht(barMax[1]);
 }
}
/////////////////////////////////////////////
function x(){
 var byteIn=0, byteOut=0, e;
 refresher.Refresh();
 e=new Enumerator(net);
 for(;!e.atEnd();e.moveNext()){
  if(NIC1==="Combined Traffic"){
   if(e.item().Name!=="MS TCP Loopback interface"){
    byteIn+=+e.item().BytesReceivedPersec/1024;
    byteOut+=+e.item().BytesSentPerSec/1024;
   }
  }
  else{
   if(e.item().Name===NIC1){
    byteIn=+e.item().BytesReceivedPersec/1024;
    byteOut=+e.item().BytesSentPerSec/1024;
   }
  }
 }
 if((byteOut>0)||(reset===true)||(upbarht[0]>0)){line1b.innerText=byteOut.thruPut();total[0]+=byteOut*interval/1024;if(byteOut>maxSpeed[0]){maxSpeed[0]=byteOut;}}
 if((byteIn>0)||(reset===true)||(dnbarht[0]>0)){line4b.innerText=byteIn.thruPut();total[1]+=byteIn*interval/1024;if(byteIn>maxSpeed[1]){maxSpeed[1]=byteIn;}}
 if((byteOut>0)||(barMax[0]>0.001)||(reset===true)){byteOut=+byteOut.toFixed(3);upbarht.unshift(byteOut);showUpHist(upbarht.length);}
 else{upbarht=[];}
 if((byteIn>0)||(barMax[1]>0.001)||(reset===true)){byteIn=+byteIn.toFixed(3);dnbarht.unshift(byteIn);showDnHist(dnbarht.length);}
 else{dnbarht=[];}
 switch(lineMode){
  case 1:line2.innerText=barMax[0].thruPut();line3.innerText=barMax[1].thruPut();break;
  case 2:line2.innerText=maxSpeed[0].thruPut();line3.innerText=maxSpeed[1].thruPut();break;
  case 3:line2.innerText=total[0].ttal();line3.innerText=total[1].ttal();break;
 }
 reset=false;
 t=setTimeout(x,interval);
}
/////////////////////////////////////////////
function xfx(){
 if(((nicInfo[0]==="0.0.0.0")||(nicInfo[0]===""))&&((nicInfo[5]==="Not Enabled")||(nicInfo[5]===""))){
  vtext.innerText=" ";
  changePage(0,6);
 }
 else{
  if(server===null){initActivX();}
  x();
  NIC2=nicInfo[2];
  setTimeout(getWan,500);
 }
}
/////////////////////////////////////////////
function refreshNic(A){
 event.cancelBubble=true;
 nDetect.innerText="Not Detected";
 rline10.style.display="none";
 nd5.style.display="block";
 nonic=2;
 getNicInfo();
 if(((nicInfo[0]==="0.0.0.0")||(nicInfo[0]===""))&&((nicInfo[5]==="Not Enabled")||(nicInfo[5]===""))){
  clearTimeout(t);clearTimeout(g);
  vtext.innerText="";
  changePage(4,6);
 }
 else{
  clearTimeout(t);
  setLines();
  changePage(4,0);
  xfx();
 }
}
function ipCall(){System.Shell.execute("cmd.exe", "/k cd %UserProfile% && ipconfig /all");}
function getNicFolder(){System.Shell.execute("control.exe", "netconnections");}
function getDevMgr(){System.Shell.execute("devmgmt.msc");}
function butOver(){act(clr[1],"","2",this);}
function butOut(){act(clr[5],"","0",this);}
function cancelEnter(){act(clr[10],"","",this,clr[4]);}
function cancelLeave(){act(clr[11],"","",this,clr[3]);}
function cancelDown(){act(clr[10],"","",this,clr[15]);}
function radioDown(){act(clr[6],"","",this,clr[15]);}
function changeMenu(A){
 ctrl1.style.display=(A===1)?"block":"none";
 ctrl0.style.display=(A===1)?"none":"block";
}
function pingError(A){
 var pe;
 switch(A){
  case -1:pe="Gadget VBS Error";break;
  case 11001:pe="Buffer Too Small";break;
  case 11002:pe="Destination Net Unreachable";break;
  case 11003:pe="Destination Host Unreachable";break;
  case 11004:pe="Destination Protocol Unreachable";break;
  case 11005:pe="Destination Port Unreachable";break;
  case 11006:pe="No Resources";break;
  case 11007:pe="Bad Option";break;
  case 11008:pe="Hardware Error";break;
  case 11009:pe="Packet Too Big";break;
  case 11010:pe="Request Timed Out";break;
  case 11011:pe="Bad Request";break;
  case 11012:pe="Bad Route";break;
  case 11013:pe="TimeToLive Expired Transit";break;
  case 11014:pe="TimeToLive Expired Reassembly";break;
  case 11015:pe="Parameter Problem";break;
  case 11016:pe="Source Quench";break;
  case 11017:pe="Option Too Big";break;
  case 11018:pe="Bad Destination";break;
  case 11032:pe="Negotiating IPSEC";break;
  case 11050:pe="General Failure";break;
  default:pe="Success";
 }
 return pe;
}
function sendPing(A){
 var pResult=[], addy, pe;
 addy=pingAddy.value.toString();
 pResult=PingHome(addy,2).split(";");
 pResult[0]=+pResult[0];
 pe=pingError(pResult[0]);
 ppout.innerText+=(pResult[0]===0)?"\r"+pResult[1]+" byte reply in "+pResult[2]+" ms":"\r\rError : Code "+pResult[0]+"\r"+pe+" ("+A+")";
 return [pResult[0],pResult[2]];
}
function pingToolI(rct,pav){
 if(rct>0){ppout.innerText+="\rAverage : "+(pav/(rct/25)).toFixed(2)+"ms";}
 ok6.disabled=false;ok6.style.color="#39f";
}
function pingToolH(rct,pmax,pav){
 ppout.innerText+="\rMaximum : "+pmax+"ms";
 h=setTimeout(function(){pingToolI(rct,pav);},1000);
}
function pingToolG(rct,pmin,pmax,pav){
 if(rct>0){
  ppout.innerText+="\rMinimum : "+pmin+"ms";
  h=setTimeout(function(){pingToolH(rct,pmax,pav);},1000);
 }
 else{ok6.disabled=false;ok6.style.color="#39f";}
}
function pingToolF(rct,pmin,pmax,pav){
 ppout.innerText+="\r"+rct+"% received";
 h=setTimeout(function(){pingToolG(rct,pmin,pmax,pav);},1000);
}
function pingToolE(rct,pmin,pmax,pav){
 ppout.innerText+="\r4 packets sent";
 h=setTimeout(function(){pingToolF(rct,pmin,pmax,pav);},1000);
}
function pingToolD(rct,pmin,pmax,pav){
 var q=[];
 try{
  q=sendPing(4);
  if(q[0]===0){rct+=25;q[1]=+q[1];pav+=q[1];if(q[1]<pmin){pmin=q[1];}if(q[1]>pmax){pmax=q[1];}}
  h=setTimeout(function(){pingToolE(rct,pmin,pmax,pav);},1000);
 }
 catch(e){ppout.innerText+="\rGadget Error\rIncorrect Query";ok6.disabled=false;}
}
function pingToolC(rct,pmin,pmax,pav){
 var q=[];
 try{
  q=sendPing(3);
  if(q[0]===0){rct+=25;q[1]=+q[1];pav+=q[1];if(q[1]<pmin){pmin=q[1];}if(q[1]>pmax){pmax=q[1];}}
  h=setTimeout(function(){pingToolD(rct,pmin,pmax,pav);},1000);
 }
 catch(e){ppout.innerText+="\rGadget Error\rIncorrect Query";ok6.disabled=false;}
}
function pingToolB(rct,pmin,pmax,pav){
 var q=[];
 try{
  q=sendPing(2);
  if(q[0]===0){rct+=25;q[1]=+q[1];pav+=q[1];if(q[1]<pmin){pmin=q[1];}if(q[1]>pmax){pmax=q[1];}}
  h=setTimeout(function(){pingToolC(rct,pmin,pmax,pav);},1000);
 }
 catch(e){ppout.innerText+="\rGadget Error\rIncorrect Query";ok6.disabled=false;}
}
function pingToolA(){
 var rct=0, pmin=20000, pmax=0, pav=0, q=[];
 try{
  q=sendPing(1);
  if(q[0]===0){rct+=25;q[1]=+q[1];pav+=q[1];pmin=pmax=q[1];}
  h=setTimeout(function(){pingToolB(rct,pmin,pmax,pav);},1000);
 }
 catch(e){ppout.innerText+="\rGadget Error\rIncorrect Query\rCheck name/address";ok6.disabled=false;}
}
function pingTool(){
 clearTimeout(h);
 ok6.disabled=true;
 if(pingAddy.value===""){ppout.innerText+="\r\rError - Please enter IP address or name above";ok6.disabled=false;}
 else{
  ppout.innerText+="\r\rPinging "+pingAddy.value+"\r\r";
  h=setTimeout(pingToolA,500);
 }
}
function goPingPage(A){
 event.cancelBubble=true;
 changePage(A,7);
 pingAddy.value=oGD.getElementById("pingStore").value;
 ppout.innerText="Enter IP address\ror\rname above\r";
}
function nicFailPingTool(){
 goPingPage(6);
}
function nicFailPing(){
 var a;
 a=PingHome("127.0.0.1",1);
 nDetect.innerText=(a===true)?"Ping 127.0.0.1 OK":"Ping 127.0.0.1 FAIL";
 this.innerText="Ping Tool";
 this.onclick=nicFailPingTool;
}
function addPingAddress(A,B){
 var i, addEntry=0;
 if(A!==""){
  for(i=0;i<B;i++){
   if(pingStore.options(i).value===A){
    addEntry="\rAddress Already Saved";
   }
  }
  if(addEntry===0){
   pingStore.options.add(new Option(A,A));
   addEntry="\rSaved Address OK";
   pingStore.options(pingStore.length-1).selected="selected";
  }
  ppout.innerText+=addEntry;
 }
}
function delPingAddress(A,B){
 var i, delEntry="\rAddress Not Listed";
 if(A!==""){
  for(i=B;i>0;i--){
   if(pingStore.options(i-1).value===A){
    delEntry="\rDeleted Address OK";
    pingStore.remove(i-1);
   }
  }
  ppout.innerText+=delEntry;
 }
}
function saveIpList(){
 var i, j=pingStore.options.length, k=ipList.length, ipL=[], s=false;
 clearTimeout(h);
 changePage(7,0);
 ppout.innerText="";
 ok6.disabled=false;ok6.style.color="#39f";
 for(i=1;i<j;i++){ipL[i-1]=pingStore.options(i).value;}
 if(k!==(j-1)){s=true;}
 else{for(i=0;i<j-1;i++){if(ipL[i]!==ipList[i]){s=true;break;}}}
 if(s===true){
  System.Gadget.Settings.write("ipList",ipL);
  ipList=ipL;
 }
}
function hMirror(A,B,C){
 var lmax;
 if(+hDir[A]!==C){
  lmax=(lineMode===0)?110:30;
  clearTimeout(g);
  if(+hDir[A]===0){
   B.style.left=(10+lmax-histoLength)+"px";
   B.filters.item(1).Mirror=1;
   hDir[A]=1;
  }
  else{
   B.style.left="10px";
   B.filters.item(1).Mirror=0;
   hDir[A]=0;
  }
  setButtons(40,45);
  g=setTimeout(saveSettings,5000);
 }
 changePage(4,0);
}
function setMirror(){
 var lE, mI, lmax=(lineMode===0)?110:30;
 if(hDir[0]===0){lE="10px";mI=0;}
 else{lE=(10+lmax-histoLength)+"px";mI=1;}
 uphist.style.left=lE;
 uphist.filters.item(1).Mirror=mI;
 if(hDir[1]===0){lE="10px";mI=0;}
 else{lE=(10+lmax-histoLength)+"px";mI=1;}
 dnhist.style.left=lE;
 dnhist.filters.item(1).Mirror=mI;
}
function midClickPaste(){
 var a=checkRtClick();
 if(a===true){getNicInfo();}
 if(((nicInfo[0]==="0.0.0.0")||(nicInfo[0]===""))&&((nicInfo[5]==="Not Enabled")||(nicInfo[5]===""))){clearTimeout(t);clearTimeout(g);clearTimeout(b);changePage(0,6);}
 else{boxInfo(true);}
}
function mAct(){
 var i, el;
 page0.onclick=changeLines;
 ctrl.onmouseenter=function(){changeMenu(1);};
 ctrl.onmouseleave=function(){changeMenu(0);};
 infobox.onmousedown=midClickPaste;
 for(i=0;i<5;i++){el=oGD.getElementById("but"+i);el.onmouseenter=butOver;el.onmouseleave=butOut;}
 but2.onclick=function(){event.cancelBubble=true;changePage(0,3);};
 but0.onclick=function(){event.cancelBubble=true;changePage(0,4);};
 but1.onclick=function(){event.cancelBubble=true;changePage(0,2);};
 but3.onclick=function(){event.cancelBubble=true;loadInputs();changePage(0,1);};
 but4.onclick=function(){goPingPage(0);};
 addList.onclick=function(){addPingAddress(pingAddy.value,pingStore.length);};
 remList.onclick=function(){delPingAddress(pingAddy.value,pingStore.length);};
 addList.onmouseenter=function(){act("#9f9","","",this,clr[4]);};
 addList.onmouseleave=function(){act("#3f3","","",this,clr[3]);};
 remList.onmouseenter=function(){act("#f99","","",this,clr[4]);};
 remList.onmouseleave=function(){act("#f33","","",this,clr[3]);};
 pingStore.onchange=function(){pingAddy.value=pingStore.options(pingStore.selectedIndex).value;ppout.innerText="\rReady ...\r";h=setTimeout(function(){ppout.innerText+='\r\r';},300);};
 pingStore.onmouseenter=function(){act("#3f3","","",arrowCover);};
 pingStore.onmouseleave=function(){act("#08f","","",arrowCover);};
 NICselect1.onmouseenter=function(){act("#3f3","","",arrowCover2);};
 NICselect1.onmouseleave=function(){act("#08f","","",arrowCover2);};
 NICselect2.onmouseenter=function(){act("#3f3","","",arrowCover3);};
 NICselect2.onmouseleave=function(){act("#08f","","",arrowCover3);};
 arrowCover.onmouseenter=function(){act("#f66","","",this);};
 arrowCover.onmouseleave=function(){act("#f00","","",this);};
 pingAddy.onkeypress=function(){if(event.keyCode===13){pingTool();}};
 for(i=1;i<7;i++){el=oGD.getElementById("cancel"+i);el.onmouseenter=cancelEnter;el.onmouseleave=cancelLeave;el.onmousedown=cancelDown;}
 cancel1.onclick=function(){changePage(1,0);closeLines2();loadInputs();};
 for(i=2;i<6;i++){oGD.getElementById("cancel"+i).onclick=changePage;}
 cancel6.onclick=saveIpList;
 ok1.onclick=function(){changeBarMax(+upInput.value,+dnInput.value);};
 ok5.onclick=saveNic;
 ok6.onclick=pingTool;
 ok1.onmouseenter=ok5.onmouseenter=ok6.onmouseenter=function(){act(clr[9],"","",this,clr[4]);};
 ok1.onmouseleave=ok5.onmouseleave=ok6.onmouseleave=function(){act(clr[0],"","",this,clr[3]);};
 ok1.onmousedown=ok5.onmousedown=ok6.onmousedown=function(){act(clr[0],"","",this,clr[15]);};
 radio0.onclick=function(){auto=0;changeBarMax(5,5);};
 radio1.onclick=function(){auto=0;changeBarMax(6,32);};
 radio2.onclick=function(){auto=0;changeBarMax(8,64);};
 radio3.onclick=function(){auto=0;changeBarMax(32,192);};
 radio4.onclick=function(){auto=0;changeBarMax(48,1000);};
 radio5.onclick=function(){auto=0;changeBarMax(81920,81920);};
 radio6.onclick=function(){auto=(auto!==1)?1:0;changeBarMax(autoMin,autoMin);};
 radio7.onclick=function(){changeBarMin(0);};
 radio8.onclick=function(){changeBarMin(0.1);};
 radio9.onclick=function(){changeBarMin(1);};
 for(i=10;i<25;i++){oGD.getElementById("radio"+i).onclick=(i<16)?changeInterval:changePrecision;}
 radio25.onclick=refreshNic;
 radio26.onclick=selectNic;
 radio27.onclick=function(){pushLine(0,0,this);};
 radio28.onclick=function(){pushLine(4,3,this);};
 radio29.onclick=function(){pushLine(1,1,this);};
 radio30.onclick=function(){pushLine(3,4,this);};
 radio31.onclick=function(){pushLine(2,2,this);};
 radio32.onclick=function(){resetTotals(1);closeLines();changePage(4,0);};
 radio33.onclick=function(){resetTotals("",1);closeLines();changePage(4,0);};
 radio34.onclick=function(){resetTotals(1,1);closeLines();changePage(4,0);};
 radio35.onclick=function(){pushLine(5,3,rline4);};
 radio36.onclick=function(){pushLine(6,3,rline4);};
 radio37.onclick=function(){pushLine(7,3,rline4);};
 radio38.onclick=function(){changeHistF(0);};
 radio39.onclick=function(){changeHistF(1);};
 radio40.onclick=function(){hMirror(0,uphist,0);};
 radio41.onclick=function(){hMirror(0,uphist,1);};
 radio42.onclick=function(){hMirror(1,dnhist,0);};
 radio43.onclick=function(){hMirror(1,dnhist,1);};
 radio44.onclick=function(){ipCall();changePage(4,0);closeLines();};
 radio45.onclick=function(){getNicFolder();changePage(4,0);closeLines();};
 radio46.onclick=function(){getDevMgr();changePage(4,0);closeLines();};
 radio47.onclick=function(){pushLine(8,0,rline0);};
 radio48.onclick=function(){pushLine(9,0,rline0);};
 radio49.onclick=changeAutoMin;
 radio50.onclick=changeAutoMin;
 radio51.onclick=changeAutoMin;
 upInput.onkeypress=dnInput.onkeypress=function(){if(event.keyCode===13){changeBarMax(+upInput.value,+dnInput.value);}};
 upInput.onfocus=dnInput.onfocus=function(){auto=0;setButtons(6,7);};
 NICselect1.onchange=NICselect1.onfocus=function(){chooseNIC(1);};
 NICselect2.onchange=NICselect2.onfocus=function(){chooseNIC(2);};
 i=0;while(el=oGD.getElementsByTagName("Button").item(i++)){el.hideFocus=true;el.onmousedown=radioDown;}
 for(i=0;i<6;i++){el=oGD.getElementById("nd"+i);el.onmouseenter=el.onmouseup=offButtonIn;el.onmouseleave=offButtonOut;el.onmousedown=radioDown;}
 nd1.onclick=function(){nDetect.innerText="Not Detected"+" ( x "+nonic+" )";nonic++;getNicInfo();changePage(6,0);setLines();xfx();};
 nd0.onclick=nicFailPing;
 nd2.onclick=ipCall;
 nd3.onclick=getNicFolder;
 nd4.onclick=getDevMgr;
 nd5.onclick=function(){pushLine(10,5,this);};
}
//////////////////////////////////////////////////////////////////////////////////////////////////
function fx(){
 var mode, i, j, oSGS=System.Gadget.Settings;
 NIC1=(oSGS.read("NIC1")!=="")?oSGS.read("NIC1"):"Combined Traffic";
 NIC2=(oSGS.read("NIC2")!=="")?oSGS.read("NIC2"):false;
 getNicInfo();
 mode=(oSGS.read("mode")!=="")?oSGS.readString("mode").split(","):[barMax[0],barMax[1],barMin,precision[0],precision[1],precision[2],interval,lineMode,auto,fMode,autoMin,hDir[0],hDir[1]];
 ipList=(oSGS.read("ipList")!=="")?oSGS.readString("ipList").split(","):["127.0.0.1","google.com","speedtest.net","192.168.0.1","192.168.0.2","192.168.0.3"];
 for(i=0,j=ipList.length;i<j;i++){pingStore.options.add(new Option(ipList[i],ipList[i]));}
 pingStore.options(1).selected="selected";
 barMax=[+mode[0],+mode[1]];barMin=+mode[2];precision=[+mode[3],+mode[4],+mode[5]];interval=+mode[6];lineMode=+mode[7];auto=+mode[8];fMode=+mode[9];autoMin=+mode[10];hDir=[+mode[11],+mode[12]];
 if(autoMin<=0){autoMin=0.001;}
 setHistF(fMode);setTitles();setButtons(0,52);setLines();setMirror();mAct();
 line1b.innerText=line4b.innerText=(0).thruPut();
 setTimeout(xfx,500);
}
function loadPerm(){
 var myDocs=System.Shell.knownFolderPath("Documents"), fso=new ActiveXObject("Scripting.FileSystemObject"), sFile, i, j, cV;
 sFile=fso.OpenTextFile(myDocs+"\\Mystifeid Gadgets\\nicslim.txt", 1, false, 0);
 cV=sFile.Readline().loadFloat();
 sFile.SkipLine();
 barMax[0]=sFile.Readline().loadFloat();
 barMax[1]=sFile.Readline().loadFloat();
 barMin=sFile.Readline().loadInt();
 precision[0]=sFile.Readline().loadInt();
 precision[1]=sFile.Readline().loadInt();
 precision[2]=sFile.Readline().loadInt();
 interval=sFile.Readline().loadInt();
 lineMode=sFile.Readline().loadInt();
 auto=sFile.Readline().loadInt();
 fMode=sFile.Readline().loadInt();
 autoMin=sFile.Readline().loadFloat();
 ipList=sFile.Readline().split("=")[1].split(",");
 NIC1=sFile.Readline().split("=")[1];
 NIC2=sFile.Readline().split("=")[1];
 if(isNaN(cV)){hDir=[0,0];}
 else{
  hDir[0]=sFile.Readline().loadInt();
  hDir[1]=sFile.Readline().loadInt();
 }
 sFile.Close();
 for(i=pingStore.options.length;i>1;i--){pingStore.remove(i-1);}
 for(i=0,j=ipList.length;i<j;i++){pingStore.options.add(new Option(ipList[i],ipList[i]));}
 pingStore.options(1).selected="selected";
 reset=true;
 setButtons(0,52);
 setLines();setMirror();
 saveSettings();
 System.Gadget.Settings.write("NIC1",NIC1);
 System.Gadget.Settings.write("NIC2",NIC2);
 System.Gadget.Settings.write("ipList",ipList);
 nDetect.innerText="Not Detected";
 nonic=2;
 getNicInfo();
 if(((nicInfo[0]==="0.0.0.0")||(nicInfo[0]===""))&&((nicInfo[5]==="Not Enabled")||(nicInfo[5]===""))){vtext.innerText="";changePage(0,6);}
 else{x();getWan();}
 boxInfo();
 fso=null;
}
function savePerm(){
 var gFolder, myDocs=System.Shell.knownFolderPath('Documents'), fso=new ActiveXObject("Scripting.FileSystemObject"), sFile;
 try{gFolder=System.Shell.itemFromPath(myDocs+"\\Mystifeid Gadgets").isFolder;}
 catch(e){gFolder=System.Shell.itemFromPath(myDocs);gFolder=gFolder.SHFolder;gFolder.newFolder("Mystifeid Gadgets",0);}
 sFile=fso.CreateTextFile(myDocs+"\\Mystifeid Gadgets\\nicslim.txt", true);
 sFile.WriteLine("$('nic').slim Settings - Version = "+System.Gadget.version.substr(1));//version intro in v1.25
 sFile.WriteBlankLines(1);
 sFile.WriteLine("Upload Peak Value    = "+barMax[0]);
 sFile.WriteLine("Download Peak Value  = "+barMax[1]);
 sFile.WriteLine("Histogram Min Value  = "+barMin);
 sFile.WriteLine("KB precision         = "+precision[0]);
 sFile.WriteLine("MB precision         = "+precision[1]);
 sFile.WriteLine("GB precision         = "+precision[2]);
 sFile.WriteLine("Interval             = "+interval);
 sFile.WriteLine("Info Mode (0 - 6)    = "+lineMode);
 sFile.WriteLine("Auto Status (0, 1)   = "+auto);
 sFile.WriteLine("Bar Filter (0, 1)    = "+fMode);
 sFile.WriteLine("Auto Min Peak (>0)   = "+autoMin);
 sFile.WriteLine("IP List              ="+ipList);
 sFile.WriteLine("Data NIC             ="+NIC1);
 sFile.WriteLine("Info NIC             ="+NIC2);
 sFile.WriteLine("Up Histo Direction   = "+hDir[0]);
 sFile.WriteLine("Dn Histo Direction   = "+hDir[1]);
 sFile.WriteLine("Note - while you can use this file to set some values outside normal operating parameters, care should be taken.");
 sFile.Close();
 fso=null;
}
function SettingsClosed(event){
 if(event.closeAction===event.Action.commit){
  var s=System.Gadget.Settings.readString("saveLoadPerm");
  if(+s===0){savePerm();}
  if(+s===1){clearTimeout(t);clearTimeout(g);clearTimeout(h);clearTimeout(b);setTimeout(loadPerm,750);}
 }
}
System.Gadget.onSettingsClosed=SettingsClosed;
